// This file is generated by kconfig_compiler_kf6 from nightlightsettings.kcfg.
// All changes you do to this file will be lost.
#ifndef NIGHTLIGHTSETTINGS_H
#define NIGHTLIGHTSETTINGS_H

#include <enum.h>

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class NightLightSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    NightLightSettings( QObject *parent = nullptr );
    ~NightLightSettings() override;

    /**
      Set ActiveEnabled
    */
    void setActiveEnabled( bool v )
    {
      if (v != mActiveEnabled && !isActiveEnabledImmutable()) {
        mActiveEnabled = v;
        Q_EMIT ActiveEnabledChanged();
      }
    }

    Q_PROPERTY(bool activeEnabled READ activeEnabled WRITE setActiveEnabled NOTIFY ActiveEnabledChanged)
    Q_PROPERTY(bool isActiveEnabledImmutable READ isActiveEnabledImmutable CONSTANT)
    /**
      Get ActiveEnabled
    */
    bool activeEnabled() const
    {
      return mActiveEnabled;
    }

    /**
      Is ActiveEnabled Immutable
    */
    bool isActiveEnabledImmutable() const
    {
      return isImmutable( QStringLiteral( "ActiveEnabled" ) );
    }

    /**
      Get ActiveEnabled default value
    */
    bool defaultActiveEnabledValue() const
    {
        return defaultActiveEnabledValue_helper();
    }

    /**
      Set Active
    */
    void setActive( bool v )
    {
      if (v != mActive && !isActiveImmutable()) {
        mActive = v;
        Q_EMIT ActiveChanged();
      }
    }

    Q_PROPERTY(bool active READ active WRITE setActive NOTIFY ActiveChanged)
    Q_PROPERTY(bool isActiveImmutable READ isActiveImmutable CONSTANT)
    /**
      Get Active
    */
    bool active() const
    {
      return mActive;
    }

    /**
      Is Active Immutable
    */
    bool isActiveImmutable() const
    {
      return isImmutable( QStringLiteral( "Active" ) );
    }

    /**
      Get Active default value
    */
    bool defaultActiveValue() const
    {
        return defaultActiveValue_helper();
    }

    /**
      Set ModeEnabled
    */
    void setModeEnabled( bool v )
    {
      if (v != mModeEnabled && !isModeEnabledImmutable()) {
        mModeEnabled = v;
        Q_EMIT ModeEnabledChanged();
      }
    }

    Q_PROPERTY(bool modeEnabled READ modeEnabled WRITE setModeEnabled NOTIFY ModeEnabledChanged)
    Q_PROPERTY(bool isModeEnabledImmutable READ isModeEnabledImmutable CONSTANT)
    /**
      Get ModeEnabled
    */
    bool modeEnabled() const
    {
      return mModeEnabled;
    }

    /**
      Is ModeEnabled Immutable
    */
    bool isModeEnabledImmutable() const
    {
      return isImmutable( QStringLiteral( "ModeEnabled" ) );
    }

    /**
      Get ModeEnabled default value
    */
    bool defaultModeEnabledValue() const
    {
        return defaultModeEnabledValue_helper();
    }

    /**
      Set Mode
    */
    void setMode( ColorCorrect::NightLightMode v )
    {
      if (v != mMode && !isModeImmutable()) {
        mMode = v;
        Q_EMIT ModeChanged();
      }
    }

    Q_PROPERTY(ColorCorrect::NightLightMode mode READ mode WRITE setMode NOTIFY ModeChanged)
    Q_PROPERTY(bool isModeImmutable READ isModeImmutable CONSTANT)
    /**
      Get Mode
    */
    ColorCorrect::NightLightMode mode() const
    {
      return static_cast<ColorCorrect::NightLightMode>(mMode);
    }

    /**
      Is Mode Immutable
    */
    bool isModeImmutable() const
    {
      return isImmutable( QStringLiteral( "Mode" ) );
    }

    /**
      Get Mode default value
    */
    ColorCorrect::NightLightMode defaultModeValue() const
    {
        return static_cast<ColorCorrect::NightLightMode>(defaultModeValue_helper());
    }

    /**
      Set NightTemperatureEnabled
    */
    void setNightTemperatureEnabled( bool v )
    {
      if (v != mNightTemperatureEnabled && !isNightTemperatureEnabledImmutable()) {
        mNightTemperatureEnabled = v;
        Q_EMIT NightTemperatureEnabledChanged();
      }
    }

    Q_PROPERTY(bool nightTemperatureEnabled READ nightTemperatureEnabled WRITE setNightTemperatureEnabled NOTIFY NightTemperatureEnabledChanged)
    Q_PROPERTY(bool isNightTemperatureEnabledImmutable READ isNightTemperatureEnabledImmutable CONSTANT)
    /**
      Get NightTemperatureEnabled
    */
    bool nightTemperatureEnabled() const
    {
      return mNightTemperatureEnabled;
    }

    /**
      Is NightTemperatureEnabled Immutable
    */
    bool isNightTemperatureEnabledImmutable() const
    {
      return isImmutable( QStringLiteral( "NightTemperatureEnabled" ) );
    }

    /**
      Get NightTemperatureEnabled default value
    */
    bool defaultNightTemperatureEnabledValue() const
    {
        return defaultNightTemperatureEnabledValue_helper();
    }

    /**
      Set DayTemperature
    */
    void setDayTemperature( int v )
    {
      if (v < 1000)
      {
        qDebug() << "setDayTemperature: value " << v << " is less than the minimum value of 1000";
        v = 1000;
      }

      if (v > 6500)
      {
        qDebug() << "setDayTemperature: value " << v << " is greater than the maximum value of 6500";
        v = 6500;
      }

      if (v != mDayTemperature && !isDayTemperatureImmutable()) {
        mDayTemperature = v;
        Q_EMIT DayTemperatureChanged();
      }
    }

    Q_PROPERTY(int dayTemperature READ dayTemperature WRITE setDayTemperature NOTIFY DayTemperatureChanged)
    Q_PROPERTY(bool isDayTemperatureImmutable READ isDayTemperatureImmutable CONSTANT)
    /**
      Get DayTemperature
    */
    int dayTemperature() const
    {
      return mDayTemperature;
    }

    /**
      Is DayTemperature Immutable
    */
    bool isDayTemperatureImmutable() const
    {
      return isImmutable( QStringLiteral( "DayTemperature" ) );
    }

    /**
      Get DayTemperature default value
    */
    int defaultDayTemperatureValue() const
    {
        return defaultDayTemperatureValue_helper();
    }

    /**
      Set NightTemperature
    */
    void setNightTemperature( int v )
    {
      if (v < 1000)
      {
        qDebug() << "setNightTemperature: value " << v << " is less than the minimum value of 1000";
        v = 1000;
      }

      if (v > 6500)
      {
        qDebug() << "setNightTemperature: value " << v << " is greater than the maximum value of 6500";
        v = 6500;
      }

      if (v != mNightTemperature && !isNightTemperatureImmutable()) {
        mNightTemperature = v;
        Q_EMIT NightTemperatureChanged();
      }
    }

    Q_PROPERTY(int nightTemperature READ nightTemperature WRITE setNightTemperature NOTIFY NightTemperatureChanged)
    Q_PROPERTY(bool isNightTemperatureImmutable READ isNightTemperatureImmutable CONSTANT)
    /**
      Get NightTemperature
    */
    int nightTemperature() const
    {
      return mNightTemperature;
    }

    /**
      Is NightTemperature Immutable
    */
    bool isNightTemperatureImmutable() const
    {
      return isImmutable( QStringLiteral( "NightTemperature" ) );
    }

    /**
      Get NightTemperature default value
    */
    int defaultNightTemperatureValue() const
    {
        return defaultNightTemperatureValue_helper();
    }

    /**
      Set LatitudeAuto
    */
    void setLatitudeAuto( double v )
    {
      if (v != mLatitudeAuto && !isLatitudeAutoImmutable()) {
        mLatitudeAuto = v;
        Q_EMIT LatitudeAutoChanged();
      }
    }

    Q_PROPERTY(double latitudeAuto READ latitudeAuto WRITE setLatitudeAuto NOTIFY LatitudeAutoChanged)
    Q_PROPERTY(bool isLatitudeAutoImmutable READ isLatitudeAutoImmutable CONSTANT)
    /**
      Get LatitudeAuto
    */
    double latitudeAuto() const
    {
      return mLatitudeAuto;
    }

    /**
      Is LatitudeAuto Immutable
    */
    bool isLatitudeAutoImmutable() const
    {
      return isImmutable( QStringLiteral( "LatitudeAuto" ) );
    }

    /**
      Get LatitudeAuto default value
    */
    double defaultLatitudeAutoValue() const
    {
        return defaultLatitudeAutoValue_helper();
    }

    /**
      Set LongitudeAuto
    */
    void setLongitudeAuto( double v )
    {
      if (v != mLongitudeAuto && !isLongitudeAutoImmutable()) {
        mLongitudeAuto = v;
        Q_EMIT LongitudeAutoChanged();
      }
    }

    Q_PROPERTY(double longitudeAuto READ longitudeAuto WRITE setLongitudeAuto NOTIFY LongitudeAutoChanged)
    Q_PROPERTY(bool isLongitudeAutoImmutable READ isLongitudeAutoImmutable CONSTANT)
    /**
      Get LongitudeAuto
    */
    double longitudeAuto() const
    {
      return mLongitudeAuto;
    }

    /**
      Is LongitudeAuto Immutable
    */
    bool isLongitudeAutoImmutable() const
    {
      return isImmutable( QStringLiteral( "LongitudeAuto" ) );
    }

    /**
      Get LongitudeAuto default value
    */
    double defaultLongitudeAutoValue() const
    {
        return defaultLongitudeAutoValue_helper();
    }

    /**
      Set LocationEnabled
    */
    void setLocationEnabled( bool v )
    {
      if (v != mLocationEnabled && !isLocationEnabledImmutable()) {
        mLocationEnabled = v;
        Q_EMIT LocationEnabledChanged();
      }
    }

    Q_PROPERTY(bool locationEnabled READ locationEnabled WRITE setLocationEnabled NOTIFY LocationEnabledChanged)
    Q_PROPERTY(bool isLocationEnabledImmutable READ isLocationEnabledImmutable CONSTANT)
    /**
      Get LocationEnabled
    */
    bool locationEnabled() const
    {
      return mLocationEnabled;
    }

    /**
      Is LocationEnabled Immutable
    */
    bool isLocationEnabledImmutable() const
    {
      return isImmutable( QStringLiteral( "LocationEnabled" ) );
    }

    /**
      Get LocationEnabled default value
    */
    bool defaultLocationEnabledValue() const
    {
        return defaultLocationEnabledValue_helper();
    }

    /**
      Set LatitudeFixed
    */
    void setLatitudeFixed( double v )
    {
      if (v != mLatitudeFixed && !isLatitudeFixedImmutable()) {
        mLatitudeFixed = v;
        Q_EMIT LatitudeFixedChanged();
      }
    }

    Q_PROPERTY(double latitudeFixed READ latitudeFixed WRITE setLatitudeFixed NOTIFY LatitudeFixedChanged)
    Q_PROPERTY(bool isLatitudeFixedImmutable READ isLatitudeFixedImmutable CONSTANT)
    /**
      Get LatitudeFixed
    */
    double latitudeFixed() const
    {
      return mLatitudeFixed;
    }

    /**
      Is LatitudeFixed Immutable
    */
    bool isLatitudeFixedImmutable() const
    {
      return isImmutable( QStringLiteral( "LatitudeFixed" ) );
    }

    /**
      Get LatitudeFixed default value
    */
    double defaultLatitudeFixedValue() const
    {
        return defaultLatitudeFixedValue_helper();
    }

    /**
      Set LongitudeFixed
    */
    void setLongitudeFixed( double v )
    {
      if (v != mLongitudeFixed && !isLongitudeFixedImmutable()) {
        mLongitudeFixed = v;
        Q_EMIT LongitudeFixedChanged();
      }
    }

    Q_PROPERTY(double longitudeFixed READ longitudeFixed WRITE setLongitudeFixed NOTIFY LongitudeFixedChanged)
    Q_PROPERTY(bool isLongitudeFixedImmutable READ isLongitudeFixedImmutable CONSTANT)
    /**
      Get LongitudeFixed
    */
    double longitudeFixed() const
    {
      return mLongitudeFixed;
    }

    /**
      Is LongitudeFixed Immutable
    */
    bool isLongitudeFixedImmutable() const
    {
      return isImmutable( QStringLiteral( "LongitudeFixed" ) );
    }

    /**
      Get LongitudeFixed default value
    */
    double defaultLongitudeFixedValue() const
    {
        return defaultLongitudeFixedValue_helper();
    }

    /**
      Set MorningBeginFixed
    */
    void setMorningBeginFixed( const QString & v )
    {
      if (v != mMorningBeginFixed && !isMorningBeginFixedImmutable()) {
        mMorningBeginFixed = v;
        Q_EMIT MorningBeginFixedChanged();
      }
    }

    Q_PROPERTY(QString morningBeginFixed READ morningBeginFixed WRITE setMorningBeginFixed NOTIFY MorningBeginFixedChanged)
    Q_PROPERTY(bool isMorningBeginFixedImmutable READ isMorningBeginFixedImmutable CONSTANT)
    /**
      Get MorningBeginFixed
    */
    QString morningBeginFixed() const
    {
      return mMorningBeginFixed;
    }

    /**
      Is MorningBeginFixed Immutable
    */
    bool isMorningBeginFixedImmutable() const
    {
      return isImmutable( QStringLiteral( "MorningBeginFixed" ) );
    }

    /**
      Get MorningBeginFixed default value
    */
    QString defaultMorningBeginFixedValue() const
    {
        return defaultMorningBeginFixedValue_helper();
    }

    /**
      Set EveningBeginFixed
    */
    void setEveningBeginFixed( const QString & v )
    {
      if (v != mEveningBeginFixed && !isEveningBeginFixedImmutable()) {
        mEveningBeginFixed = v;
        Q_EMIT EveningBeginFixedChanged();
      }
    }

    Q_PROPERTY(QString eveningBeginFixed READ eveningBeginFixed WRITE setEveningBeginFixed NOTIFY EveningBeginFixedChanged)
    Q_PROPERTY(bool isEveningBeginFixedImmutable READ isEveningBeginFixedImmutable CONSTANT)
    /**
      Get EveningBeginFixed
    */
    QString eveningBeginFixed() const
    {
      return mEveningBeginFixed;
    }

    /**
      Is EveningBeginFixed Immutable
    */
    bool isEveningBeginFixedImmutable() const
    {
      return isImmutable( QStringLiteral( "EveningBeginFixed" ) );
    }

    /**
      Get EveningBeginFixed default value
    */
    QString defaultEveningBeginFixedValue() const
    {
        return defaultEveningBeginFixedValue_helper();
    }

    /**
      Set TransitionTime
    */
    void setTransitionTime( int v )
    {
      if (v != mTransitionTime && !isTransitionTimeImmutable()) {
        mTransitionTime = v;
        Q_EMIT TransitionTimeChanged();
      }
    }

    Q_PROPERTY(int transitionTime READ transitionTime WRITE setTransitionTime NOTIFY TransitionTimeChanged)
    Q_PROPERTY(bool isTransitionTimeImmutable READ isTransitionTimeImmutable CONSTANT)
    /**
      Get TransitionTime
    */
    int transitionTime() const
    {
      return mTransitionTime;
    }

    /**
      Is TransitionTime Immutable
    */
    bool isTransitionTimeImmutable() const
    {
      return isImmutable( QStringLiteral( "TransitionTime" ) );
    }

    /**
      Get TransitionTime default value
    */
    int defaultTransitionTimeValue() const
    {
        return defaultTransitionTimeValue_helper();
    }


    enum {
      signalActiveEnabledChanged = 1,
      signalActiveChanged = 2,
      signalModeEnabledChanged = 3,
      signalModeChanged = 4,
      signalNightTemperatureEnabledChanged = 5,
      signalDayTemperatureChanged = 6,
      signalNightTemperatureChanged = 7,
      signalLatitudeAutoChanged = 8,
      signalLongitudeAutoChanged = 9,
      signalLocationEnabledChanged = 10,
      signalLatitudeFixedChanged = 11,
      signalLongitudeFixedChanged = 12,
      signalMorningBeginFixedChanged = 13,
      signalEveningBeginFixedChanged = 14,
      signalTransitionTimeChanged = 15
    };

  Q_SIGNALS:
    void ActiveEnabledChanged();

    void ActiveChanged();

    void ModeEnabledChanged();

    void ModeChanged();

    void NightTemperatureEnabledChanged();

    void DayTemperatureChanged();

    void NightTemperatureChanged();

    void LatitudeAutoChanged();

    void LongitudeAutoChanged();

    void LocationEnabledChanged();

    void LatitudeFixedChanged();

    void LongitudeFixedChanged();

    void MorningBeginFixedChanged();

    void EveningBeginFixedChanged();

    void TransitionTimeChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:

    // NightColor
    bool mActiveEnabled;
    bool defaultActiveEnabledValue_helper() const;
    bool mActive;
    bool defaultActiveValue_helper() const;
    bool mModeEnabled;
    bool defaultModeEnabledValue_helper() const;
    int mMode;
    int defaultModeValue_helper() const;
    bool mNightTemperatureEnabled;
    bool defaultNightTemperatureEnabledValue_helper() const;
    int mDayTemperature;
    int defaultDayTemperatureValue_helper() const;
    int mNightTemperature;
    int defaultNightTemperatureValue_helper() const;
    double mLatitudeAuto;
    double defaultLatitudeAutoValue_helper() const;
    double mLongitudeAuto;
    double defaultLongitudeAutoValue_helper() const;
    bool mLocationEnabled;
    bool defaultLocationEnabledValue_helper() const;
    double mLatitudeFixed;
    double defaultLatitudeFixedValue_helper() const;
    double mLongitudeFixed;
    double defaultLongitudeFixedValue_helper() const;
    QString mMorningBeginFixed;
    QString defaultMorningBeginFixedValue_helper() const;
    QString mEveningBeginFixed;
    QString defaultEveningBeginFixedValue_helper() const;
    int mTransitionTime;
    int defaultTransitionTimeValue_helper() const;

  private:
};

#endif

